Protwarbar = LibStub("AceAddon-3.0"):NewAddon("Protwarbar", "AceEvent-3.0",  "AceConsole-3.0", "AceTimer-3.0")
local media = LibStub("LibSharedMedia-3.0")

function Protwarbar:OnInitialize()
	Protwarbar:SetDefaultMedia(media)

	self.db = LibStub('AceDB-3.0'):New('ProtwarbarDB', self:CreateDefaults(), true)
	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")

	AceConfig = LibStub("AceConfigDialog-3.0")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Protwarbar", self:CreateOptions())
	AceConfig:AddToBlizOptions("Protwarbar", "Protwarbar")

	Protwarbar:RegisterChatCommand('protwarbar', 'OnCommand')
end

	function Protwarbar:OnCommand()
	InterfaceOptionsFrame_OpenToCategory("Protwarbar")
end

function Protwarbar:RefreshConfig()
	Protwarbar:UpdateStyling()
end

function Protwarbar:UpdateStyling()
	RageFrame:SetWidth(Protwarbar.db.profile.barWidth)
	RageFrame:SetHeight(Protwarbar.db.profile.barHeight)
	RageFrame:SetMovable(not Protwarbar.db.profile.locked)
	RageFrame:SetBackdropColor(Protwarbar.db.profile.bg.r, Protwarbar.db.profile.bg.g,
		Protwarbar.db.profile.bg.b, Protwarbar.db.profile.bg.a)
	RageFrame:EnableMouse(not Protwarbar.db.profile.locked)

	RageBar:SetStatusBarTexture(media:Fetch("statusbar", Protwarbar.db.profile.barTexture))
	RageBar:SetMinMaxValues(0, UnitPowerMax("player"))
	RageBarText:SetFont(media:Fetch("font", Protwarbar.db.profile.barFont), Protwarbar.db.profile.barFontsize, "OUTLINE")

	IconFrame1:SetWidth(Protwarbar.db.profile.iconsize)
	IconFrame1:SetHeight(Protwarbar.db.profile.iconsize)
	IconFrame1:SetMovable(not Protwarbar.db.profile.locked)
	IconFrame1:EnableMouse(not Protwarbar.db.profile.locked)

	IconFrame2:SetWidth(Protwarbar.db.profile.iconsize)
	IconFrame2:SetHeight(Protwarbar.db.profile.iconsize)
	IconFrame2:SetMovable(not Protwarbar.db.profile.locked)  
	IconFrame2:EnableMouse(not Protwarbar.db.profile.locked)

	VengeanceFrame:SetWidth(Protwarbar.db.profile.VengeanceWidth)
	VengeanceFrame:SetHeight(Protwarbar.db.profile.VengeanceHeight)
	VengeanceFrame:SetMovable(not Protwarbar.db.profile.locked)  
	VengeanceFrame:EnableMouse(not Protwarbar.db.profile.locked)
	VengeanceText:SetFont(media:Fetch("font", Protwarbar.db.profile.VengeanceFont), Protwarbar.db.profile.VengeanceFontsize, "OUTLINE")


	if Protwarbar.db.profile.locked then
		IconFrame1:SetBackdropColor(1, 1, 1, 0)
		IconFrame2:SetBackdropColor(1, 1, 1, 0)
		VengeanceFrame:SetBackdropColor(1, 1, 1, 0)
	else
		IconFrame1:SetBackdropColor(1, 1, 1, 1)
		IconFrame2:SetBackdropColor(1, 1, 1, 1)
		VengeanceFrame:SetBackdropColor(1, 1, 1, 1)
	end


	-- Toggle display of vengeance
	if Protwarbar.db.profile.VengeanceEnabled and Protwarbar.db.profile.enabled then
		VengeanceFrame:Show()		
	else
		VengeanceFrame:Hide()
	end

	-- Toggle display of everything
	if Protwarbar.db.profile.enabled then
		RageFrame:Show()
		IconFrame1:Show()
		IconFrame2:Show()
	else
		RageFrame:Hide()
		IconFrame1:Hide()
		IconFrame2:Hide()
	end



end

function Protwarbar:OnEnable()
	local _, playerClass = UnitClass("player")

	Protwarbar:Print("Ping")
	if playerClass == "WARRIOR" then
		self:RegisterEvent("UNIT_POWER")
		self:RegisterEvent("UNIT_MAXPOWER")
		self:RegisterEvent("UNIT_AURA");
		
		Protwarbar:BuildGui()
		-- force update the bar every .5 seconds
		self:ScheduleRepeatingTimer("TimerFeedback", 0.5)
	else
		Protwarbar:Print("Protwarbar has been loaded but not enabled. Player is not a warrior.")
	end
end

function Protwarbar:BuildGui()
	-- Ragebar frame setup
	RageFrame = CreateFrame("Frame", nil, UIParent)
	RageFrame:SetFrameStrata("BACKGROUND")
	RageFrame:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = false})
	RageFrame:SetPoint("BOTTOMLEFT", Protwarbar.db.profile.x, Protwarbar.db.profile.y)

	-- Ragebar frame movement
	RageFrame:RegisterForDrag('LeftButton')
	RageFrame:SetClampedToScreen(true)
	RageFrame:SetScript("OnDragStart", dragstart)
	RageFrame:SetScript('OnDragStop', dragstop)

	-- Ragebar setup
	RageBar = CreateFrame("StatusBar",nil,RageFrame)
	RageBar:SetOrientation("HORIZONTAL")
	RageBar:SetMinMaxValues(0, UnitPowerMax("player"))
	RageBar:SetValue(UnitPower("player"))
	RageBar:SetAllPoints(RageFrame)

	-- Ragebar text setup
	RageBarText = RageBar:CreateFontString(nil, 'OVERLAY')
	RageBarText:SetPoint("CENTER", RageFrame, 0, 0);
	RageBarText:SetFont(media:Fetch("font", Protwarbar.db.profile.barFont), Protwarbar.db.profile.barFontsize, "OUTLINE")
	RageBarText:SetText(UnitPower("player"))

	-- Icon1 frame setup
	IconFrame1 = CreateFrame("Frame", nil, UIParent)
	IconFrame1:SetFrameStrata("BACKGROUND")
	IconFrame1:SetPoint("BOTTOMLEFT", Protwarbar.db.profile.IF1x, Protwarbar.db.profile.IF1y)
	IconFrame1:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = false})

	-- Icon1 frame movement
	IconFrame1:RegisterForDrag('LeftButton')
	IconFrame1:SetClampedToScreen(true)
	IconFrame1:SetScript("OnDragStart", dragstart)
	IconFrame1:SetScript('OnDragStop', dragstop)

	-- Icon1 texture
	IconFrame1.texture = IconFrame1:CreateTexture()
	IconFrame1.texture:SetAllPoints(IconFrame1)
	IconFrame1.texture:SetTexture(GetSpellTexture(6673))

	-- Icon2 frame setup
	IconFrame2 = CreateFrame("Frame", nil, UIParent)
	IconFrame2:SetFrameStrata("BACKGROUND")
	IconFrame2:SetPoint("BOTTOMLEFT", Protwarbar.db.profile.IF2x, Protwarbar.db.profile.IF2y)
	IconFrame2:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = false})

	-- Icon2 frame movement
	IconFrame2:RegisterForDrag('LeftButton')
	IconFrame2:SetClampedToScreen(true)
	IconFrame2:SetScript("OnDragStart", dragstart)
	IconFrame2:SetScript('OnDragStop', dragstop)

	-- Icon2 texture
	IconFrame2.texture = IconFrame2:CreateTexture()
	IconFrame2.texture:SetAllPoints(IconFrame2)
	IconFrame2.texture:SetTexture(GetSpellTexture(18499))

	-- Vengeance frame setup
	VengeanceFrame = CreateFrame("Frame", nil, UIParent)
	VengeanceFrame:SetFrameStrata("BACKGROUND")
	VengeanceFrame:SetPoint("BOTTOMLEFT", Protwarbar.db.profile.VenFx, Protwarbar.db.profile.VenFy)
	VengeanceFrame:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = false})

	-- Vengeance frame movement
	VengeanceFrame:RegisterForDrag('LeftButton')
	VengeanceFrame:SetClampedToScreen(true)
	VengeanceFrame:SetScript("OnDragStart", dragstart)
	VengeanceFrame:SetScript('OnDragStop', dragstop)

	-- Vengeance text
	VengeanceText = VengeanceFrame:CreateFontString(nil, 'OVERLAY')
	VengeanceText:SetPoint("LEFT", 4, 0);
	VengeanceText:SetFont(media:Fetch("font", Protwarbar.db.profile.VengeanceFont), Protwarbar.db.profile.VengeanceFontsize, "OUTLINE")
	VengeanceText:SetText(0)

	Protwarbar:UpdateStyling()

	if Protwarbar.db.profile.enabled then
		RageFrame:Show()
		IconFrame1:Show()
		IconFrame2:Show()
	end
end

function Protwarbar:TimerFeedback()
	Protwarbar:UpdateRageBar(UnitPower("player"))
end

function Protwarbar:UNIT_POWER(arg1,arg2,arg3)
	if (arg2 == "player") then
		Protwarbar:UpdateRageBar(UnitPower("player"))
	end
end

function Protwarbar:UNIT_AURA(eventName, arg1)
	if (arg1 == "player") then
		Protwarbar:UpdateRageBar(UnitPower("player"))
	end
end

function Protwarbar:UNIT_MAXPOWER()
	Protwarbar:UpdateStyling()
end

function Protwarbar:UpdateRageBar(power)
	RageBar:SetValue(power)

	if power == UnitPowerMax("player") then
		RageBar:SetStatusBarColor(Protwarbar.db.profile.colorMax.r, Protwarbar.db.profile.colorMax.g,
			Protwarbar.db.profile.colorMax.b, Protwarbar.db.profile.colorMax.a)
	end
	if power < UnitPowerMax("player") then
		RageBar:SetStatusBarColor(Protwarbar.db.profile.color100.r, Protwarbar.db.profile.color100.g,
			Protwarbar.db.profile.color100.b, Protwarbar.db.profile.color100.a)
	end
	if power < 60 then
		RageBar:SetStatusBarColor(Protwarbar.db.profile.color60.r, Protwarbar.db.profile.color60.g,
			Protwarbar.db.profile.color60.b, Protwarbar.db.profile.color60.a)
	end
	if power < 20 then
		RageBar:SetStatusBarColor(Protwarbar.db.profile.color20.r, Protwarbar.db.profile.color20.g,
			Protwarbar.db.profile.color20.b, Protwarbar.db.profile.color20.a)
	end

	RageBarText:SetText(power)

	local BattleshoutID = 6673
	local BerserkerRageID = 18499

	updateIcon(BattleshoutID, IconFrame1)
	updateIcon(BerserkerRageID, IconFrame2)

	local n,_,_,_,_,_,_,_,_,_,id,_,_,val1,val2,val3 = UnitAura("player", "Vengeance", nil, "HELPFUL");
	if n then
		local vengeance = val1 or 0
		local ventext = 0
		if vengeance > 0 then
			ventext = string.format("%.1f", vengeance / 1000)
		end
		VengeanceText:SetText(ventext .. "k")
	else
		VengeanceText:SetText(0)
	end
end

function updateIcon(spellID, frame)
	local start, duration, enabled = GetSpellCooldown(spellID);
	if enabled == 1 and duration > 1.5 then
		frame.texture:SetAlpha(0)
	else
		frame.texture:SetAlpha(1)
	end
end

function Protwarbar:OnDisable()
end

function dragstart(frame)
	if not Protwarbar.db.profile.locked then
		frame:StartMoving()
	end
end

function dragstop(frame)
	frame:StopMovingOrSizing()

	Protwarbar.db.profile.x = RageFrame:GetLeft()
	Protwarbar.db.profile.y = RageFrame:GetBottom()

	Protwarbar.db.profile.IF1x = IconFrame1:GetLeft()
	Protwarbar.db.profile.IF1y = IconFrame1:GetBottom()

	Protwarbar.db.profile.IF2x = IconFrame2:GetLeft()
	Protwarbar.db.profile.IF2y = IconFrame2:GetBottom()

	Protwarbar.db.profile.VenFx = VengeanceFrame:GetLeft()
	Protwarbar.db.profile.VenFy = VengeanceFrame:GetBottom()

end